diff --git a/src/main/java/net/minecraft/client/input/controller/ControllerType.java b/src/main/java/net/minecraft/client/input/controller/ControllerType.java
new file mode 100644
index 000000000..399cc6eae
--- /dev/null
+++ b/src/main/java/net/minecraft/client/input/controller/ControllerType.java
@@ -0,0 +1,64 @@
+package net.minecraft.client.input.controller;
+
+import net.minecraft.client.input.glfw.GlfwGamepad;
+import java.util.Arrays;
+import java.util.List;
+
+public enum ControllerType {
+    UNKNOWN(Category.XBOX, "xbox", "UNKNOWN"),
+    XBOX360(Category.XBOX, "xbox", "XBOX 360"),
+    XBOXONE(Category.XBOX, "xbox", "XBOX ONE"),
+    PS3(Category.PLAYSTATION, "playstation", "PLAYSTATION 3"),
+    PS4(Category.PLAYSTATION, "playstation", "PLAYSTATION 4"),
+    PS5(Category.PLAYSTATION, "playstation", "PLAYSTATION 5"),
+    NINTENDO_SWITCH_PRO(Category.NINTENDO, "nintendo", "NINTENDO SWITCH PRO");
+
+    private final Category category;
+    private final String assetName;
+    private final String printableName;
+
+    ControllerType(Category category, String assetName, String printableName) {
+        this.category = category;
+        this.assetName = assetName;
+        this.printableName = printableName;
+    }
+
+    public static ControllerType fromController(GlfwGamepad controller) {
+        List<String> name = Arrays.asList(controller.getName().toLowerCase().split(" "));
+        if (name.contains("xbox") || name.contains("xinput")) {
+            if (name.contains("one")) {
+                return XBOXONE;
+            }
+            return XBOX360;
+        }
+        if ((name.contains("playstation") && name.contains("3")) || name.contains("ps3")) {
+            return PS3;
+        } else if ((name.contains("playstation") && name.contains("4")) || name.contains("ps4")) {
+            return PS4;
+        } else if ((name.contains("playstation") && name.contains("5")) || name.contains("ps5")) {
+            return PS5;
+        } else if (name.contains("nintendo") && name.contains("switch") && name.contains("pro")) {
+            return NINTENDO_SWITCH_PRO;
+        } else {
+            return UNKNOWN;
+        }
+    }
+
+    public Category getCategory() {
+        return this.category;
+    }
+
+    public String getAssetName() {
+        return this.assetName;
+    }
+
+    public String getPrintableName() {
+        return this.printableName;
+    }
+
+    public enum Category {
+        XBOX,
+        PLAYSTATION,
+        NINTENDO;
+    }
+}
diff --git a/src/main/java/net/minecraft/client/input/controller/DigitalPad.java b/src/main/java/net/minecraft/client/input/controller/DigitalPad.java
index c049fc1c0..49ea31c1b 100644
--- a/src/main/java/net/minecraft/client/input/controller/DigitalPad.java
+++ b/src/main/java/net/minecraft/client/input/controller/DigitalPad.java
@@ -4,20 +4,16 @@ import net.java.games.input.Component;
 
 public class DigitalPad {
 	
-	public final ControllerInput controller;
-	
 	public IButton up;
 	public IButton left;
 	public IButton down;
 	public IButton right;
 	
-	public DigitalPad(ControllerInput controller, Component component) {
-		this.controller = controller;
-
-		up = new Button("Digital Up", component, (comp) -> comp.getPollData() > 0.1 && comp.getPollData() < 0.4);
-		right = new Button("Digital Right", component, (comp) -> comp.getPollData() > 0.3 && comp.getPollData() < 0.7);
-		down = new Button("Digital Down", component, (comp) -> comp.getPollData() > 0.6 && comp.getPollData() < 0.9);
-		left = new Button("Digital Left", component, (comp) -> (comp.getPollData() > 0.8 || comp.getPollData() < 0.2) && comp.getPollData() > 0.0);
+	public DigitalPad(IButton up, IButton left, IButton down, IButton right) {
+		this.up = up;
+		this.down = down;
+		this.left = left;
+		this.right = right;
 	}
 	
 	public void update() {
diff --git a/src/main/java/net/minecraft/client/input/controller/IButtonListener.java b/src/main/java/net/minecraft/client/input/controller/IButtonListener.java
index d7a9b3ce6..69168223d 100644
--- a/src/main/java/net/minecraft/client/input/controller/IButtonListener.java
+++ b/src/main/java/net/minecraft/client/input/controller/IButtonListener.java
@@ -4,6 +4,6 @@ import net.java.games.input.Component;
 
 public interface IButtonListener {
 	
-	public boolean isPressed(Component comp);
+	boolean isPressed(int button);
 	
 }
diff --git a/src/main/java/net/minecraft/client/input/controller/IJoystickListener.java b/src/main/java/net/minecraft/client/input/controller/IJoystickListener.java
new file mode 100644
index 000000000..1da7189d8
--- /dev/null
+++ b/src/main/java/net/minecraft/client/input/controller/IJoystickListener.java
@@ -0,0 +1,5 @@
+package net.minecraft.client.input.controller;
+
+public interface IJoystickListener {
+    float getValue(int axis);
+}
diff --git a/src/main/java/net/minecraft/client/input/controller/Joystick.java b/src/main/java/net/minecraft/client/input/controller/Joystick.java
index 8af8ab1a2..cb7f710b1 100644
--- a/src/main/java/net/minecraft/client/input/controller/Joystick.java
+++ b/src/main/java/net/minecraft/client/input/controller/Joystick.java
@@ -1,11 +1,10 @@
 package net.minecraft.client.input.controller;
 
-import net.java.games.input.Component;
 import net.minecraft.client.option.FloatOption;
 
 public class Joystick{
-	
-	public Component compX, compY;
+	public int xAxis, yAxis;
+	public IJoystickListener joystickListener;
 	public final String name;
 	
 	public final Button button;
@@ -14,12 +13,13 @@ public class Joystick{
 	
 	private boolean moving = false;
 	private boolean moveLastFrame = false;
-	
-	public Joystick(String name, Component x, Component y, Button button, FloatOption deadzone) {
+
+	public Joystick(String name, int xAxis, int yAxis, IJoystickListener joystickListener, Button button, FloatOption deadzone) {
 		this.name = name;
 		this.deadzone = deadzone;
-		this.compX = x;
-		this.compY = y;
+		this.xAxis = xAxis;
+		this.yAxis = yAxis;
+		this.joystickListener = joystickListener;
 		this.button = button;
 	}
 	
@@ -38,8 +38,8 @@ public class Joystick{
 	public void update() {
 		button.update();
 		
-		float x = this.compX.getPollData();
-		float y = this.compY.getPollData();
+		float x = this.joystickListener.getValue(xAxis);
+		float y = this.joystickListener.getValue(yAxis);
 		
 		boolean xInDeadzone = x < deadzone.value && x > -deadzone.value;
 		boolean yInDeadzone = y < deadzone.value && y > -deadzone.value;
diff --git a/src/main/java/net/minecraft/client/input/glfw/GlfwGamepad.java b/src/main/java/net/minecraft/client/input/glfw/GlfwGamepad.java
new file mode 100644
index 000000000..8bc096f35
--- /dev/null
+++ b/src/main/java/net/minecraft/client/input/glfw/GlfwGamepad.java
@@ -0,0 +1,49 @@
+package net.minecraft.client.input.glfw;
+
+import org.lwjgl.glfw.GLFW;
+import org.lwjgl.glfw.GLFWGamepadState;
+
+import java.nio.ByteBuffer;
+
+public class GlfwGamepad extends GlfwJoystick {
+    private GLFWGamepadState state = null;
+
+    public GlfwGamepad(int id) {
+        super(id);
+    }
+
+    @Override
+    public void poll() {
+        super.poll();
+        this.state = new GLFWGamepadState(ByteBuffer.allocateDirect(GLFWGamepadState.SIZEOF));
+        GLFW.glfwGetGamepadState(this.getId(), this.state);
+    }
+
+    @Override
+    public String getName() {
+        return GLFW.glfwGetGamepadName(this.getId());
+    }
+
+    @Override
+    public float getAxisValue(int axis) {
+        if (this.state != null && axis >= 0 && axis < this.state.axes().capacity()) {
+            return this.state.axes().get(axis);
+        }
+
+        return 0.0F;
+    }
+
+    @Override
+    public boolean isButtonPressed(int button) {
+        if (this.state != null && button >= 0 && button < this.state.buttons().capacity()) {
+            return this.state.buttons().get(button) == GLFW.GLFW_PRESS;
+        }
+
+        return false;
+    }
+
+    @Override
+    public GlfwGamepad intoGamepad() {
+        return this;
+    }
+}
diff --git a/src/main/java/net/minecraft/client/input/glfw/GlfwJoystick.java b/src/main/java/net/minecraft/client/input/glfw/GlfwJoystick.java
new file mode 100644
index 000000000..31b2401f8
--- /dev/null
+++ b/src/main/java/net/minecraft/client/input/glfw/GlfwJoystick.java
@@ -0,0 +1,68 @@
+package net.minecraft.client.input.glfw;
+
+import org.lwjgl.glfw.GLFW;
+
+import java.nio.ByteBuffer;
+import java.nio.FloatBuffer;
+
+public class GlfwJoystick {
+    private final int id;
+    private FloatBuffer axes = null;
+    private ByteBuffer buttons = null;
+    private ByteBuffer hats = null;
+    private GlfwGamepad gamepad = null;
+
+    public GlfwJoystick(int id) {
+        this.id = id;
+    }
+
+    public int getId() {
+        return this.id;
+    }
+
+    public void poll() {
+        this.axes = GLFW.glfwGetJoystickAxes(this.id);
+        this.buttons = GLFW.glfwGetJoystickButtons(this.id);
+        this.hats = GLFW.glfwGetJoystickHats(this.id);
+    }
+
+    public boolean isPresent() {
+        return GLFW.glfwJoystickPresent(this.id);
+    }
+
+    public String getName() {
+        return GLFW.glfwGetJoystickName(this.id);
+    }
+
+    public float getAxisValue(int axis) {
+        if (isPresent() && axes != null && axis >= 0 && axis < axes.capacity()) {
+            return axes.get(axis);
+        }
+
+        return 0.0F;
+    }
+
+    public boolean isButtonPressed(int button) {
+        if (isPresent() && buttons != null && button >= 0 && button < buttons.capacity()) {
+            return buttons.get(button) == GLFW.GLFW_PRESS;
+        }
+
+        return false;
+    }
+
+    public int getHatValue(int hat) {
+        if (isPresent() && hats != null && hat >= 0 && hat < hats.capacity()) {
+            return hats.get(hat);
+        }
+
+        return GLFW.GLFW_HAT_CENTERED;
+    }
+
+    public GlfwGamepad intoGamepad() {
+        if (gamepad == null && isPresent() && GLFW.glfwJoystickIsGamepad(this.id)) {
+            gamepad = new GlfwGamepad(id);
+        }
+
+        return gamepad;
+    }
+}
